| OpendTect 8.0

Loading...
Searching...
No Matches
Classes | Public Member Functions | Protected Member Functions | Private Attributes | Friends | List of all members
ReflectivityModelBase Class Reference
Algo

A TimeDepth model set that includes reflectivities. Base class for offset and angle based reflectivity models. More...

`#include <reflectivitymodel.h>`

Inheritance diagram for ReflectivityModelBase:
[legend]

## Classes
class | Setup

## Public Member Functions
Seis::OffsetType | getAzimuthType () const
Seis::OffsetType | getOffsetType () const
const float * | getReflDepths () const
const ReflectivityModelTrace * | getReflectivities (int ioff) const
const float * | getReflTimes (int ioff=-1) const
| ioff=-1 for default TD model
float | getSinAngle (int ioff, int idz) const
bool | hasAngles () const
bool | hasReflectivities () const
virtual bool | isAngleDomain () const
virtual bool | isOffsetDomain () const
bool | isSpikeDefined (int ioff, int idz) const
int | nrLayers () const
int | nrRefModels () const
int | nrSpikes () const
Public Member Functions inherited from TimeDepthModelSet
| TimeDepthModelSet (const ElasticModel &, const Setup &=Setup(), const TypeSet< float > *axisvals=nullptr, float *velmax=nullptr)
| TimeDepthModelSet (const TimeDepthModel &, const TypeSet< float > *axisvals=nullptr)
void | forceTimes (const TimeDepthModel &, bool defonly)
const TimeDepthModel * | get (int) const
const TimeDepthModel & | getDefaultModel () const
virtual bool | isOK () const
int | modelSize () const
int | nrModels () const
void | setDefTWT (int idz, float)
void | setDepth (int idz, float)
void | setTWT (int imdl, int idz, float)
int | size () const
Public Member Functions inherited from RefCount::Referenced
void | addObserver (WeakPtrBase *obs)
| Not for normal use. May become private.
int | nrRefs () const
| Only for expert use.
void | ref () const
bool | refIfReffed () const
| Don't use in production, for debugging.
void | removeObserver (WeakPtrBase *obs)
| Not for normal use. May become private.
bool | tryRef () const
| Not for normal use. May become private.
void | unRef () const
void | unRefNoDelete () const

## Protected Member Functions
| ReflectivityModelBase (const ElasticModel &, const ReflectivityModelBase::Setup &, const TypeSet< float > *axisvals=nullptr, float *velmax=nullptr)
| ReflectivityModelBase (const ElasticModel &, const TypeSet< float > &anglevals, const ReflectivityModelBase::Setup &)
| Angle-based models only.
| ~ReflectivityModelBase ()
float * | getAngles (int ioff)
ReflectivityModelTrace * | getReflectivities (int ioff)
float_complex * | getRefs (int ioff)
Protected Member Functions inherited from TimeDepthModelSet
virtual | ~TimeDepthModelSet ()
Protected Member Functions inherited from RefCount::Referenced
| Referenced ()
| Referenced (const Referenced &)
virtual | ~Referenced ()
Referenced & | operator= (const Referenced &)

## Private Attributes
Seis::OffsetType | azimuthtype_ = Seis::OffsetType::AngleRadians
int | nroffs_
Seis::OffsetType | offsettype_ = Seis::OffsetType::OffsetMeter
RefObjectSet< ReflectivityModelTrace > * | reflectivities_ = nullptr
float ** | sinarr_ = nullptr
float * | sini_ = nullptr

## Friends
class | RayTracer1D
class | ReflCalc1D

## Additional Inherited Members
Static Public Member Functions inherited from RefCount::Referenced
static bool | isSane (const Referenced *)
Protected Attributes inherited from TimeDepthModelSet
bool | isbad_ = false

## Detailed Description

A TimeDepth model set that includes reflectivities. Base class for offset and angle based reflectivity models.

<>

## Constructor & Destructor Documentation

## ◆ ReflectivityModelBase() [1/2]

ReflectivityModelBase::ReflectivityModelBase | ( | const ElasticModel & | ,
|  | const ReflectivityModelBase::Setup & | ,
|  | const TypeSet< float > * | axisvals = nullptr,
|  | float * | velmax = nullptr )
| protected

## ◆ ReflectivityModelBase() [2/2]

ReflectivityModelBase::ReflectivityModelBase | ( | const ElasticModel & | ,
|  | const TypeSet< float > & | anglevals,
|  | const ReflectivityModelBase::Setup & | )
| protected

Angle-based models only.

## ◆ ~ReflectivityModelBase()

ReflectivityModelBase::~ReflectivityModelBase | ( |  | ) |
| protected

## Member Function Documentation

## ◆ getAngles()

float * ReflectivityModelBase::getAngles | ( | int | ioff | ) |
| protected

## ◆ getAzimuthType()

Seis::OffsetType ReflectivityModelBase::getAzimuthType | ( |  | ) | const
| inline

## ◆ getOffsetType()

Seis::OffsetType ReflectivityModelBase::getOffsetType | ( |  | ) | const
| inline

## ◆ getReflDepths()

const float * ReflectivityModelBase::getReflDepths | ( |  | ) | const

## ◆ getReflectivities() [1/2]

ReflectivityModelTrace * ReflectivityModelBase::getReflectivities | ( | int | ioff | ) |
| protected

## ◆ getReflectivities() [2/2]

const ReflectivityModelTrace * ReflectivityModelBase::getReflectivities | ( | int | ioff | ) | const

## ◆ getReflTimes()

const float * ReflectivityModelBase::getReflTimes | ( | int | ioff = -1 | ) | const

ioff=-1 for default TD model

## ◆ getRefs()

float_complex * ReflectivityModelBase::getRefs | ( | int | ioff | ) |
| protected

## ◆ getSinAngle()

float ReflectivityModelBase::getSinAngle | ( | int | ioff,
|  | int | idz ) const

## ◆ hasAngles()

bool ReflectivityModelBase::hasAngles | ( |  | ) | const

## ◆ hasReflectivities()

bool ReflectivityModelBase::hasReflectivities | ( |  | ) | const

## ◆ isAngleDomain()

virtual bool ReflectivityModelBase::isAngleDomain | ( |  | ) | const
| inline virtual

Reimplemented in AngleReflectivityModel.

## ◆ isOffsetDomain()

virtual bool ReflectivityModelBase::isOffsetDomain | ( |  | ) | const
| inline virtual

Reimplemented in OffsetReflectivityModel.

## ◆ isSpikeDefined()

bool ReflectivityModelBase::isSpikeDefined | ( | int | ioff,
|  | int | idz ) const

## ◆ nrLayers()

int ReflectivityModelBase::nrLayers | ( |  | ) | const

## ◆ nrRefModels()

int ReflectivityModelBase::nrRefModels | ( |  | ) | const

## ◆ nrSpikes()

int ReflectivityModelBase::nrSpikes | ( |  | ) | const

## Friends And Related Symbol Documentation

## ◆ RayTracer1D

friend class RayTracer1D
| friend

## ◆ ReflCalc1D

friend class ReflCalc1D
| friend

## Member Data Documentation

## ◆ azimuthtype_

Seis::OffsetType ReflectivityModelBase::azimuthtype_ = Seis::OffsetType::AngleRadians
| private

## ◆ nroffs_

int ReflectivityModelBase::nroffs_
| private

## ◆ offsettype_

Seis::OffsetType ReflectivityModelBase::offsettype_ = Seis::OffsetType::OffsetMeter
| private

## ◆ reflectivities_

RefObjectSet<ReflectivityModelTrace>* ReflectivityModelBase::reflectivities_ = nullptr
| private

## ◆ sinarr_

float** ReflectivityModelBase::sinarr_ = nullptr
| private

## ◆ sini_

float* ReflectivityModelBase::sini_ = nullptr
| private

Generated at
for the OpendTect seismic interpretation project. Copyright (C): dGB Beheer B.V. 1995-2025